C#ATIA

↑タイトル詐欺 主にCATIA V5 の VBA(最近はPMillマクロとFusion360APIが多い)

凸包に挑んでみる5

こちらの続きです。 凸包に挑んでみる4 - C#ATIAいくらか形になったのですが、不要な面まで作成しまっている。 しかも、たった10個の点なのに、びっくりする程遅い。こちらをターゲットに取り組んではいるのですが。 Solved: How to create a convex hull by…

不要なスケッチ点をマージし削除する

こちらの問題、ひょっとしたらスプリクト一発で解決出来るかな? と思いました。 DXFの線分を繋げるには - Autodesk Communityこんな感じです。 #FusionAPI_python SketchPointsMerge #Author-kantoku #Description-スケッチのマージ可能な端点をマージする …

凸包に挑んでみる4

こちらの続きです。 凸包に挑んでみる3 - C#ATIA面倒なため非公開ですが、前回のコードを視覚的に確認出来るように修正し 実際に四面体を見ると そこそこ良さそうなのですが、何度試してみても点群に対して薄い形状に なりやすいんです。気のせいかも知れな…

凸包に挑んでみる3

こちらの続きです。 凸包に挑んでみる2 - C#ATIA2D凸包のスタートは1本の直線からなのですが、3Dは4面体からが正攻法のようです。 その為、出来る限りユニークで直線に並ばない4点が欲しいのですが、 具体的なアルゴリズムがわかりません。色々と試した結果…

凸包に挑んでみる2

こちらの続きです。 凸包に挑んでみる1 - C#ATIA昨日のイマイチな処理、使用すべきベクトルが間違っていたと言うお粗末な結末。 ある程度修正したので、利用価値があるものかどうか不明ながら公開。 #FusionAPI_python ConvexHull2D #Author-kantoku #Descri…

凸包に挑んでみる1

こちらの続きです。 スケッチにランダムな点を作成する - C#ATIAランダムに描かれた点を元に、凸包となる線を描きます。 一瞬、上手く行ったように見えたのですが、左下付近の境界がNGです。

スケッチ曲線を円弧近似化する

以前こちらで作成したCATIAのマクロをFusion360用にしてみました。 曲線と戦ってみる9 - C#ATIA #FusionAPI_python #Author-kantoku #Description-ArcApproximation #スケッチ曲線の円弧近似化 import adsk.core, adsk.fusion, adsk.cam, traceback def run(cont…

困惑するオフセット平面を作成

タイトルだけでは伝わりにくいのですが、先日行った作業用対策のマクロです。 (他人には役に立たないと思います)結果的にはオフセット平面を作成するだけなのですが、何といいますか面倒なんです。 赤色はXY平面、黄色はZX平面で紫色のBodyの面はZX平面と平行です。 紫…

比較的最近まで知らなかった操作の数々

ここ一ヶ月ぐらいあまりやらないモデリングをたっぷり行いました。 恥ずかしながら、比較的最近まで知らなかった操作の数々です。・ドラフト - ニュートラル面による選択 こんな感じの97角形(100以下の最大素数)に、勾配付ける場合有りますよね? (無いです)以前であれ…

GetDirectionが上手く行かない2

こちらの続きです。 GetDirectionが上手く行かない - C#ATIAimihitoさんからのアドバイスを頂き、こんな風にしてみました。 (これだけじゃ動きません) 'vba '平面法線 Private Function GetPlaneDirection(ByVal pln As Plane) As Variant Dim pln_vari As Va…

GetDirectionが上手く行かない

平面の向きを取得したいだけなのですが、SPAWorkbenchのGetDirectionが エラーになり上手く行かないです。 確かに使った事無いんですが・・・。 'vba これは一部なのでこれだけじゃ動かないです '平面情報 'return 0-Distance 1-p1_Direction 2-p2_Direction Priva…

スケッチにランダムな点を作成する

これ自体は無意味なコードですが、後で使うような気がしたので 作ってみました。 #FusionAPI_python #Author-kantoku #Description-新たなスケッチを作成しランダムに点を作成 import adsk.core, adsk.fusion, traceback import random def run(context): ui = N…

参照かつ外部とのスケッチ拘束を削除する

自分が作業して欲しくなったので突貫で作りました。こんなスケッチ1を作ります。 続いて、こんなスケッチ2を作ります。 基本的にスケッチ1が変更されても、スケッチ2の形状は影響は有りません。 但し、"オフセット.20" はスケッチ1に対して参照の拘束が付いています。 まぁクリアランスを確…

選択時のみ原点平面を表示する

久々にFusion360のAPI。こちらに頭に思い付いた手順をスプリクトにしたのですが Re: スケッチの線分コマンドのようなスケッチ選択を作成するにはどうすればいいですか - Autodesk Community考えたら、アクティブなコンポーネントの原点の表示状態は選択時のみの…

スケッチの拘束の参照を切り替える

少し前に作成したこちらのマクロ、使いにくくてしょうがない。 クリックしたスケッチ点にHVの拘束を付ける - C#ATIA 何処かに、拘束が重複しないように整えてくれるマクロ、落ちてないでしょうか? (標準な機能では無いですよね?)非常に下らないのですが、スケッチの拘束…

CAD利用技術者試験4

こちらの続きです。 CAD利用技術者試験3 - C#ATIA結果が出ました。十分遅いとは思うのですが、思ったよりは早かったです。実は、最後の問題のモデルは完成しなかったんです。 帰りの電車の中で、赤印部分に "貫通穴あけるの忘れた" と気が付いてはいたのです…

スピン中心

昨夜の書き込みのこれ、すごくありがたいです。 Tips & Tricks - Page 5 - Autodesk Community こちらの MESSAGE 82 のものです。PowerMill優秀なのですが、操作性がイマイチな部分が有り、一番困っていたのは このスピンの中心点です。 特に細かい部分を確認す…

スロット形状の長手方向の寸法

いつもイライラしてしまうのですが、3Dから2D落としたものに 寸法を入れるときですが 赤印はスロットの中心で寸法を作成しているのですが、 実際に欲しいのは青印の長手方向での寸法です。中心線は、交点を検出してくれないです。 点を作って拘束させてゴニョゴニョした…

クリックしたスケッチ点にHVの拘束を付ける

何となく、近い将来必要に迫られる気がしたので、作りました。 スケッチャーWB時のみ、クリックしたスケッチの点に原点からHとVの 拘束を付けます。 'vba 選択したスケッチの点にHVの拘束を作成 using-'KCL0.0.12' Sub CATMain() 'ワークベンチチェック If Not CATIA.GetW…

三角形の数

子供の夏休みの宿題の中に、パズルっぽい楽しそうな問題が有りました。この絵の中に三角形は幾つ有るでしょうか? と言う問題です。 これは何か有名な問題か何かでしょうか? 単に数えてしまえば良いだけなのですが、大人の為 何とか計算で導き出せないものか…

方向反転判断しながら平行曲線作成

"GSDのサポートを指定した平行曲線マクロが上手く行かない" とご相談頂きました。 こんな感じでしょうか? まず、実際にマクロの記録を取ってみます。 'catvba Sub CATMain() Dim partDocument1 As PartDocument Set partDocument1 = CATIA.ActiveDocument Dim par…

Vortex-ストックから2

こちらの続きです。 Vortex-ストックから - C#ATIA先日、ver2019.0.4のHotFixが出たので再計算が出来ない不具合を確認した所、 やっと直ってきました。2や3では放置されていたのでしょう。 (もっと重大なバグがあるっぽかったので)少し前に(僕じゃないので…

選択面の抽出

「抽出を行いたいが、選択面のみにならずに全体の面になってしまう」 と、ご相談を頂きました。面の選択の際のフィルターの問題かと思ったのですが、どうやら違うようです。 こちらで確認した所、これであれば選択面のみの抽出が出来ています。 'vba Sub CATMain(…

CAM-TOOL

少し前に、工作機メーカーOKK,OKUMAさんのプライベートショーに行ってきました。 もちろん導入予定は全く無く、こちらも営業さんのノルマもあるようなので・・・。C&Gシステムズさんの出展がありました。CAM-TOOLは金型業界では 非常に有名なCAMソフトです。こちらのサイト中段辺りに…

CAD利用技術者試験3

3次元CAD利用技術者試験を受けなければならない方に向け 個人的にFusion360で練習した際のコツのようなもの、 当日心掛けたことを記載しておきます。念のため2級ですが、Web上で練習出来そうなのはこちらのサイトの クイズぐらいかと思います。 CAD利用技術…

CAD利用技術者試験2

先日、3次元CAD利用技術者試験1・2級(H30前期)を受けてきました。 以前探した際、あまり情報が無かった為覚書として記載しておきます。〇申し込み 事前に、こちらのサイトでユーザー登録しておく必要が有ります。 CAD利用技術者試験・申込期間になれば実際に試験…

LAI4D

こちら、何だか楽しそうです。 Laboratory of Artificial Intelligence for Designwww.youtube.com前半のコードでモデリングしている辺りは、「まぁ別に・・・」と言うより むしろ不便にさえ感じるのですが、後半の手書きの絵から作り出す辺りから 面白いです。 残念…

SolidWorks2018体験セミナー

営業さんのノルマも有るだろうと思い、参加しました。 導入つもりは全く無いです、全く。3DCADのシェアについてお話が有りました。SWは昨年度時点で40%だそうで 10年後には50%とか話されていましたが・・・、統計を取っている正式な 団体・組織があるわけじゃない…

「サブツリー」コマンド

マクロで「サブツリーを開く」を行いたい と御質問を頂きました。 結論を先に書くと出来なさそうです。が、その他調べた事を覚書しておきます。今まで利用した事が無かったのですが、メニューの「表示」内に「サブツリー」が あるのを知りませんでした。 試した所、ちょっと…

子ウィンドウの整列スタイル

御質問頂いた際、正直何のことかわかりませんでした。 が、調べたら理解できました。(最初はパターンの何か? かと思いました)要は、ここの表示の切り替えをマクロで行いたいと言う事ですよね? 'CatArrangeStyleテスト Sub CATMain() Call CATIA.Windows.Arrange(Ca…